PCEP extensions for Circuit Style Policies
Internet-Draft draft-sidor-pce-circuit-style-pcep-extensions-02
Samuel Sidor
Cisco Systems, Inc.
Eurovea Central 3.
Pribinova 10
Bratislava
811 09
Slovakia
ssidor@cisco.com
Zafar Ali
Cisco Systems, Inc.
zali@cisco.com
Praveen Maheshwari
Airtel India
Praveen.Maheshwari@airtel.com
Reza Rokui
Ciena
rrokui@ciena.com
Andrew Stone
Nokia
andrew.stone@nokia.com
Luay Jalil
Verizon
luay.jalil@verizon.com
Shuping Peng
Huawei Technologies
pengshuping@huawei.com
Tarek Saad
Juniper Networks
tsaad@juniper.net
Daniel Voyer
Bell Canada
daniel.voyer@bell.ca
6 July 2022
PCE Working Group
This document proposes a set of extensions for Path Computation Element Communication Protocol (PCEP) for Circuit Style Policies - Segment-Routing Policy designed to satisfy requirements for connection-oriented transport services.
New TLV is introduced to control path recomputation and new flag to add ability to request path with strict hops only.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Introduction
Usage of Segment-routing and PCEP in connection-oriented transport services require path persistancy and hop-by-hop behavior for PCE computed paths.
Circuit-Style Policy introduced in [I-D.schmutzer-pce-cs-sr-policy] requires PCEP extensions, which are covered in this document.
This document:
- Introduces possibility to request strict path from the PCE by extending LSP-EXTENDED-FLAG TLV
- Adding new TLV to encode information about disabling path recomputation for specific path to the PCE, to be carried inside the LSPA object, which is defined in [RFC5440].
- Clarifies usage of existing O-flag from RP object in Segment-routing
PCEP extensions described in this document are applicable to RSVP-TE and SR-TE.
Terminology
The following terminologies are used in this document:
ERO:
Explicit Route Object
IGP:
Interior Gateway Protocol
LSP:
Label Switched Path.
LSPA:
Label Switched Path Attributes.
OTN:
Optical Transport Network.
PCC:
Path Computation Client
PCE:
Path Computation Element
PCEP:
Path Computation Element Protocol.
SDH:
Synchronous Digital Hierarchy
SID:
Segment Identifier
SONET:
Synchronous Optical Network
SR:
Segment Routing.
SR-TE:
Segment Routing Traffic Engineering.
Overview of Extensions to PCEP
LSP-EXTENDED-FLAG TLV
O-flag is proposed in the LSP-EXTENDED-FLAG TLV, which was introduced in 5.1.2 of [I-D.ietf-pce-lsp-extended-flags] and extended with E-flag in [I-D.peng-pce-entropy-label-position]
The format of the LSP-EXTENDED-FLAG is as follows:
LSP-EXTENDED-FLAG TLV Format

       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
       |           Type=TBD1           |          Length               |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
       |                                                           |O|E|
       //                 LSP Extended Flags                          //
       |                                                               |
       +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type (16 bits): the value is TBD1 by IANA.
Length (16 bits): multiple of 4 octets.
O (Strict-Path): If set to 1, this indicates to the PCE that a path exclusively made of strict hops is required. Strict hop definition can be found in Section 4.1
PATH-RECOMPUTATION TLV
This document defines new TLV for the LSPA Object for encoding information whether path recomputation is allowed for delegated LSP. The TLV is optional. If the TLV is included in LSPA object, the PCE MUST NOT recompute path in cases specified by flags in the TLV.

0                   1                   2                   3
0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|           Type = TBD2        |             Length = 4         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|             Reserved         |      Flags                 |P|F|
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type (16 bits): the value is TBD2 by IANA.
Length (16 bits): 4 octets
Reserved:
MUST be set to zero by the sender and MUST be ignored by the receiver.
Flags:
This document defines the following flag bits. The other bits MUST be set to zero by the sender and MUST be ignored by the receiver.
- P (Permanent): If set to 1, the PCE MUST NOT recompute path even if current path is not satisfying path computation constraints. Otherwise, if this flag is cleared, then the PCE MAY recompute path if original path is invalidated.
- F (Force): If set to 1, the PCE MUST NOT update path. If flag is cleared, the PCE MAY update path based on explicit request from operator.
Operation
Strict path enforcement
PCC MAY set the O flag in LSP-EXTENDED-FLAG TLV in PCRpt message to the PCE to indicate that a path exclusively made of strict hops is required.
O flag cleared or LSP-EXTENDED-FLAG TLV not included indicates that a loose path is acceptable.
In PCUpdate or PCInitiate messages, PCE MAY set O bit if strict path is provided.
The flag is applicable only for stateful messages. Existing O flag in RP object MAY be used to indicate similar behavior in PCReq and PCRep messages as described in as described in Section 7.4.1 of [RFC5440].
If O flag is set to 1 for both stateful and stateless messages for SR paths introduced in [RFC8664], PCE MUST use only SIDs, which will use explicitly specified adjacencies for packet forwarding. For example Adjacency SIDs MAY be used, but Prefix SIDs MUST NOT be used (even if there is only one adjacency). the PCE MUST use Adjacency SIDs only.
Path recomputation
PCC MAY set flags in PATH-RECOMPUTATION TLV to control path computation behavior on PCE side. If TLV is not included, then the PCE MAY use local policy to trigger path-computation or LSP path update.
The presence of the TLV is blocking path recomputation based on various triggers like topology update, any periodic update or changed state of other LSPs in the network. LSP path MAY be modified if forwarded packets will still use same path - for example if same path can be encoded using Adjacency and Prefix SIDs, then PCE MAY switch between various representations of same path.
If P flag is cleared, the PCE MAY recompute if current path is not considered valid, for example after topology update resulting in path not satisfying LSP's path constraints, but it MUST NOT recompute path if current path is not optimal.
If P flag is set, the PCE MUST NOT recompute path during LSP lifetime even if path is invalidated. Only exception is explicit request from operator to recompute path
If F flag is cleared, path update triggered manually by operator or any northbound interface of PCE MAY be done. If flag is set the PCE CAN update path only to tear down LSP by sending PCUpdate message with empty ERO.
TLV MAY be included in PCInitiate and PCUpdate messages to indicate, which triggers will be disabled on the PCE. PCC should reflect flag values in PCRpt messages to forward requirement to other PCEs in the network.
Security Considerations
No additional security measure is required.
IANA Considerations
LSP-EXTENDED-FLAG TLV
[I-D.ietf-pce-lsp-extended-flags] defines the LSP-EXTENDED-FLAG TLV. IANA is requested to make the following assignment from the "LSP-EXTENDED-FLAG TLV Flag Field" registry:
Bit | Description | Reference
TBD1 | Strict-Path Flag (O) | This document
PATH-RECOMPUTATION TLV
IANA is requested to make the assignment of a new value for the existing "PCEP TLV Type Indicators" registry as follows:
TLV Type | TLV Name | Reference
TBD2 | PATH-RECOMPUTATION TLV | This document
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC5440]

Path Computation Element (PCE) Communication Protocol (PCEP)
JP. Vasseur, Ed.
JL. Le Roux, Ed.
March 2009
RFC 5440
DOI 10.17487/RFC5440
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8231]

Path Computation Element Communication Protocol (PCEP) Extensions for Stateful PCE
E. Crabbe
I. Minei
J. Medved
R. Varga
September 2017
RFC 8231
DOI 10.17487/RFC8231
[RFC8664]

Path Computation Element Communication Protocol (PCEP) Extensions for Segment Routing
S. Sivabalan
C. Filsfils
J. Tantsura
W. Henderickx
J. Hardwick
December 2019
RFC 8664
DOI 10.17487/RFC8664
[I-D.ietf-pce-lsp-extended-flags]

LSP Object Flag Extension of Stateful PCE
Quan Xiong
ZTE Corporation
18 October 2021
Internet-Draft draft-ietf-pce-lsp-extended-flags-01
[I-D.peng-pce-entropy-label-position]

PCEP Extension for SR-MPLS Entropy Label Position
Quan Xiong
ZTE Corporation
Shaofu Peng
ZTE Corporation
Fengwei Qin
China Mobile
2 March 2022
Internet-Draft draft-peng-pce-entropy-label-position-07
Informative References
[I-D.schmutzer-pce-cs-sr-policy]

Circuit Style Segment Routing Policies
Christian Schmutzer
Cisco Systems
Clarence Filsfils
Cisco Systems
Zafar Ali
Cisco Systems
Francois Clad
Cisco Systems
30 September 2021
Internet-Draft draft-schmutzer-pce-cs-sr-policy-00
[SONET]

Synchronous Optical Network (SONET) Basic Description including Multiplex Structure, Rates, and Formats
American National Standards Institute
January 1995
ANSI T1.105
[SDH]

Network node interface for the synchronous digital hierarchy (SDH)
International Telecommunication Union
October 2020
ITU-T Recommendation G.707